/***************************************************************/
/* Prof. Dr. Carsten Vogt                                      */
/* FH Koeln, Fak. 07 / Nachrichtentechnik                      */
/* http://www.nt.fh-koeln.de/vogt                              */
/*                                                             */
/* Loesung der Uebungsaufgabe Kapitel 4, Nr. 5                 */
/* aus "C fuer Java-Programmierer", Hanser-Verlag              */
/***************************************************************/

#include <stdio.h>

int main(void) {

 int i;

 struct flughafen_struct {
  char  kuerzel[3];
  short pos[4];
 };

 union flughafen_union {
  char  kuerzel[3];
  short pos[4];
 };

 struct flughafen_struct fs;
 union  flughafen_union  fu;

 printf("Struct-Groesse: %d Bytes\n\n",sizeof(fs));
 printf("Union-Groesse:  %d Bytes\n\n",sizeof(fu));

 fs.kuerzel[0] = fu.kuerzel[0] = 'C';
 fs.kuerzel[1] = fu.kuerzel[1] = 'G';
 fs.kuerzel[2] = fu.kuerzel[2] = 'N';

 fs.pos[0] = fu.pos[0] = 50;
 fs.pos[1] = fu.pos[1] = 52;
 fs.pos[2] = fu.pos[2] = 7;
 fs.pos[3] = fu.pos[0] = 9;

 printf("Inhalt der Struktur:\n\n");

 printf(" Kuerzel:  ");
 for (i=0;i<3;i++)
  printf("%c",fs.kuerzel[i]);
 printf("\n");

 printf(" Position: %hd Grad %hd Minuten,",fs.pos[0],fs.pos[1]);
 printf(" %hd Grad %hd Minuten\n\n",fs.pos[2],fs.pos[3]);

 printf("Inhalt der Union:\n\n");

 printf(" Kuerzel:  ");
 for (i=0;i<3;i++)
  printf("%c",fu.kuerzel[i]);
 printf("\n");

 printf(" Position: %hd Grad %hd Minuten,",fu.pos[0],fu.pos[1]);
 printf(" %hd Grad %hd Minuten\n\n",fu.pos[2],fu.pos[3]);

 return 0;

}
