/***************************************************************/
/* Prof. Dr. Carsten Vogt                                      */
/* FH Koeln, Fak. 07 / Nachrichtentechnik                      */
/* http://www.nt.fh-koeln.de/vogt                              */
/*                                                             */
/* Loesung der Uebungsaufgabe Kapitel 6, Nr. 3                 */
/* aus "C fuer Java-Programmierer", Hanser-Verlag              */
/***************************************************************/

#include <stdio.h>

void dreheFloats(float array[], int laenge) {
 int i;
 float hilf;
 for (i=0;i<laenge/2;i++) {
   hilf = array[i];
   array[i] = array[laenge-i-1];
   array[laenge-i-1] = hilf;
  }
}

void dreheString(char array[]) {
 int i, laenge;
 char hilf;
 laenge = strlen(array);  // Laenge kann per strlen() ermittelt werden,
                          // daher kein gesonderter Parameter noetig 
 for (i=0;i<laenge/2;i++) {
   hilf = array[i];
   array[i] = array[laenge-i-1];
   array[laenge-i-1] = hilf;
  }
}

int main(void) {

 float f[] = { 0.5, 1.0, 1.5, 2.0, 2.5, 3.0, 3.5 };
 char s[] = "regensburg";
 int i;

 dreheFloats(f,7);

 printf("f nach dem Drehen: ");
 for (i=0;i<7;i++)
  printf("%.1f ",f[i]);
 printf("\n\n");

 dreheString(s);

 printf("s nach dem Drehen: %s\n",s);

 return 0;

}
